// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODEBEZIER3D_HH__
#define __NODEBEZIER3D_HH__

// ************************************************************************* //
#include "nodeshape.h"

// ************************************************************************* //
class NBezier3d: public NShape
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NBezier3d(DagNode *parent = 0): NShape(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NBezier3d(); }
  void			buildDagNodes();
  virtual void		compute(Plug &plugOut);
  void			glRender(Plug &plugOut);
};

// ************************************************************************* //
#endif//__NODEBEZIER3D_HH__

