// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#include "plug.h"
#include "datablock.h"
#include "nodeclock.h"

// ************************************************************************* //
int	NClock::typeNbr(45);
String	NClock::typeStr("Clock");

// ************************************************************************* //
/// DESCRIPTION: Create only one per scene.
/// f	- frame number, to use as input connection to other node.
/// fout	- this one is pulled at every successive frame, to use
///		  for physical simulation of phenomena.
// ************************************************************************* //
void	NClock::initialize()
{
  DataBlock	&db(getDataBlock());

  db.addInt(0, MININT, MAXINT, "sf");// start frame
  db.addInt(100, MININT, MAXINT, "ef");// end frame
  db.addInt(0, MININT, MAXINT, "f");// frame
  db.addDouble(0.0, 0.0, MAXDOUBLE, "fd");// frameDouble
  db.addDouble(1.0 / 24.0, 0.0, MAXDOUBLE, "dt");// Seconds per frame
  db.addDouble(24.0, 0.0, MAXDOUBLE, "efps");// Estimated frames per second

  db.affect("f", "fd");
}

// ************************************************************************* //
void	NClock::compute(Plug &hndOut)
{
  if (hndOut.shortName() == "fd")
    hndOut.writeAsDouble(double(readAsInt("f")));
}
