// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODEEXTRUDESHAPE_HH__
#define __NODEEXTRUDESHAPE_HH__

// ************************************************************************* //
#include "nodeshape.h"

// ************************************************************************* //
class NExtrudedShape: public NShape
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NExtrudedShape(DagNode *parent = 0): NShape(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NExtrudedShape(); }
  virtual void		compute(Plug &plugOut);
};

// ************************************************************************* //
class NCurveConstraint: public DagNode
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NCurveConstraint(DagNode *parent = 0): DagNode(parent) {}
  virtual void		initialize();
  void			buildDagNodes();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NCurveConstraint(); }
  virtual void		compute(Plug &plugOut);
};


// ************************************************************************* //
class NCoonsPatch: public NShape
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NCoonsPatch(NShape *parent = 0): NShape(parent) {}
  virtual void		initialize();
  void			buildDagNodes();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NCoonsPatch(); }
  virtual void		compute(Plug &plugOut);
};

// ************************************************************************* //
#endif//__NODEEXTRUDESHAPE_HH__
