// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODEGIZMO_HH__
#define __NODEGIZMO_HH__

// ************************************************************************* //
#include "nodeshape.h"

// ************************************************************************* //
/// DESCRIPTION: This node is a guide curve for rings.
// ************************************************************************* //
class NGizmo: public NShape
{
public:
  static int	typeNbr;
  static String	typeStr;
  static GLuint	_s_list;
public:
  NGizmo(DagNode *parent = 0): NShape(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NGizmo(); }
  void			buildDagNodes();
  virtual void		compute(Plug &plugOut);
  void			glRender(Plug &plugOut);
  void			update(Plug &plugOut);
  void	glInitLists() const;
  Vec3d	getConstrainAxis();
  void	renderTranslation(DagNode &tr);
  void	renderRotation(DagNode &tr);
  void	renderScale(DagNode &tr);
  static Pnt3d	project(const DagNode &c, const Pnt3d &p);
  static Pnt3d	unproject(const DagNode &c, const Pnt3d &p);
};

// ************************************************************************* //
#endif//__NODEGIZMO_HH__
