// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODEIMAGELAYER_HH__
#define __NODEIMAGELAYER_HH__

// ************************************************************************* //
#include "dagnode.h"

// ************************************************************************* //
/// DESCRIPTION: Root of the scene graph (node that contains the whole thing).
// ************************************************************************* //
class NImageLayer: public DagNode
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NImageLayer(DagNode *parent = 0): DagNode(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NImageLayer(); }
  void			buildDagNodes();
  virtual void		compute(Plug &plugOut);
  const Frustum		&getFrustum();
  void			glRender(Plug &plugOut);
};

// ************************************************************************* //
#endif//__NODEIMAGELAYER_HH__
