// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODESCENE_HH__
#define __NODESCENE_HH__

// ************************************************************************* //
#include "dagnode.h"
#include "datablock.h"
#include "command.h"
#include "nodeshape.h"

// ************************************************************************* //
/// DESCRIPTION: Root of the scene graph (node that contains the whole thing).
// ************************************************************************* //
class NScene: public DagNode
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  typedef enum {Modeling, Selecting, Rendering} RenderMode;
public:
  NScene(): DagNode() {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NScene(); }
  void			buildDagNodes();
  virtual void		compute(Plug &plugOut);
  void			computeRlog(Plug &plugOut);
  void			glRender(Plug &plugOut);
  void			glRenderSky();
  void			update(Plug &plugOut);
};

// ************************************************************************* //
class NWind: public NShape
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NWind(DagNode *parent = 0): NShape(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NWind(); }
  void			buildDagNodes();
  virtual void		glRender(Plug &plugOut);
  virtual void		compute(Plug &plugOut);
};

// ************************************************************************* //
#endif//__NODESCENE_HH__
