// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODESKY_HH__
#define __NODESKY_HH__

// ************************************************************************* //
#include "dagnode.h"
#ifdef _WIN32
#include "glext.h"
#endif//_WIN32

// ************************************************************************* //
/// DESCRIPTION: Root of the scene graph (node that contains the whole thing).
// ************************************************************************* //
class NSky: public DagNode
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NSky(DagNode *parent = 0): DagNode(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NSky(); }
  void			buildDagNodes();
  virtual void	compute(Plug &plugOut);
  void			glRender(Plug &plugOut);
  void			computeListLores(Plug &plugOut);
  void			computeListHires(Plug &plugOut);
  const Pnt3d	&getEye();
  const Frustum	&getFrustum();
  Pnt3d			getAimAt();
};

// ************************************************************************* //
#endif//__NODESKY_HH__
