// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:29 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODESMOKEGENERATOR_HH__
#define __NODESMOKEGENERATOR_HH__

// ************************************************************************* //
#include "gfxtypes.h"
#include "plug.h"
#include "dagnode.h"

// ************************************************************************* //
class NSmokeGenerator: public DagNode
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NSmokeGenerator(DagNode *parent = 0): DagNode(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NSmokeGenerator(); }
  void			buildDagNodes();
  virtual void		compute(Plug &hndOut);
  void			glRender(Plug &hndOut);
  void			update(Plug &hndOut);
  void		spawnInCube(const int timeRes, const int spaceRes);
  void		spawnInTorus(const int timeRes, const int spaceRes);
  void			updateReset();
};

// ************************************************************************* //
#endif//__NODESMOKEGENERATOR_HH__
