// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:30 $
/// $Revision: 1.1 $
// ************************************************************************* //
#include <GL/glu.h>
#include "nodesmokegrid.h"
#include "datablock.h"
#include "plug.h"
#include "gbb.h"

// ************************************************************************* //
int	NSmokeGrid::typeNbr(81);
String	NSmokeGrid::typeStr("SmokeGrid");

// ************************************************************************* //
void	NSmokeGrid::initialize()
{
  DataBlock	&db(getDataBlock());

  db.addInt(0, 0, MAXINT, "renderIn", false);
  db.addSignal("renderOut", false);
  db.addInt(0, MININT, MAXINT, "f", false);
  db.addSignal("update", false);

  db.affect("renderIn", "renderOut");
  db.affect("f", "update");
  buildDagNodes();
}

// ************************************************************************* //
void	NSmokeGrid::buildDagNodes()
{
  DagNode	*clock = DagNode::getNodeByPath(":Clock0");

  DagNode::connect(*clock, "f", *this, "f");
  DagNode::connect(*_m_parent, "renderIn", *this, "renderIn");
}

// ************************************************************************* //
void	NSmokeGrid::compute(Plug &hndOut)
{
  if (hndOut.shortName() == "renderOut")
    {
      static GLUquadric	*quad = gluNewQuadric();

      pushName();
      glPushMatrix();
      readAsMat4d("matParent").glMultMatrix();

      gluSphere(quad, 1.0, 16, 12);

      glPopMatrix();
      glPopName();
    }
}
