// ************************************************************************* //
/// GBB - Graphics Blue Box, by Alexis Angelidis
/// $Author: silex $
/// $Date: 2006/01/11 21:56:30 $
/// $Revision: 1.1 $
// ************************************************************************* //
#ifndef __NODEFOURIERRING_HH__
#define __NODEFOURIERRING_HH__

// ************************************************************************* //
#include "nodeshape.h"

// ************************************************************************* //
#ifndef EPSILON_JAC
#define EPSILON_JAC	1.0e-8
#endif//EPSILON_JAC

// ************************************************************************* //
class NVortexRing: public NShape
{
public:
  static int	typeNbr;
  static String	typeStr;
public:
  NVortexRing(DagNode *parent = 0): NShape(parent) {}
  virtual void		initialize();
  virtual int		getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  static DagNode	*creator() { return new NVortexRing(); }
  virtual void		compute(Plug &plugOut);
protected:
  void			buildDagNodes();
  void			glRender(Plug &plugOut);
  void			glRenderTexture();
  void			glRenderMotion();
  void			update(Plug &plugOut);
  void			updatePosition();
  void			updateHarmonics();
  void			updateBuoyancy();
  DagNode		*updateSplit();
  void			computeBBox(Plug &plugOut);
  void			computeRLog(Plug &plugOut);
  void			computeMotionSamples(Plug &plugOut);
  void			computeTextureSamples(Plug &plugOut);
  void			computePresence(Plug &plugOut);
  void			computeStrangling(Plug &plugOut);
  void			outputSamples();
  Pnt3d			motionPoint(const double a) const;
  Pnt3d			texturePoint(const double a) const;
  double		length() const;
};

// ************************************************************************* //
#endif//__NODEFOURIERRING_HH__
