// ************************************************************************* //
/// AUTHOR: Alexis Angelidis
/// STARTED: Fri Aug 26 11:11:19 NZST 2005
// ************************************************************************* //
#ifndef __PLUGOCTREE_HH__
#define __PLUGOCTREE_HH__

// ************************************************************************* //
#include "dataoctree.h"
#include "plug.h"

// ************************************************************************* //
/// DESCRIPTION: Extends a data node. This is stored in the scene graph.
// ************************************************************************* //
class PlugOctree: public Plug
{
protected:
  Octree<TwistLog>	*_m_data;
public:
  static int	typeNbr;
  static String	typeStr;
public:
  PlugOctree(DataBlock &db): Plug(db), _m_data(0) { newData(); }
  virtual ~PlugOctree() { freeData(); }
  static Plug	*creator(DataBlock &db) { return new PlugOctree(db); }
  virtual int	getTypeNbr() const { return typeNbr; }
  virtual const String	&getTypeStr() const { return typeStr; }
  virtual void	freeData() { if (_m_data) delete _m_data; _m_data = 0; }
  virtual void	newData() { if (!_m_data) _m_data = new Octree<TwistLog>; }
  virtual void	saveData(std::ostream &os) { os << *_m_data; }
  virtual void	loadData(std::istream &is) { is >> *_m_data; }
  virtual void	copy(const void *v)
  { *_m_data = *static_cast<const Octree<TwistLog>*>(v); }
  virtual void	**rawdata() { return (void**)(&_m_data); }
};

// ************************************************************************* //
#endif//__PLUGOCTREE_HH__

